import { OnInit, EventEmitter, SimpleChanges, OnChanges } from '@angular/core';
export declare class NgDatepickerComponent implements OnInit, OnChanges {
    initDate: any;
    isHidden: boolean;
    minDate: any;
    maxDate: any;
    disabledDates: (Date | string)[];
    availableDates: (Date | string)[];
    displayDateType: boolean;
    quickDateBars: QuickDateBar[];
    selectedQuickDateBar: QuickDateBar;
    daysOfWeekDisabled: number[];
    ngModelChange: EventEmitter<any>;
    private displayDate;
    private dates;
    private titleYear;
    private titleMonth;
    private pickerTitle;
    private today;
    private monthDays;
    private monthFullName;
    private monthName;
    private _minDate;
    private _maxDate;
    private _disabledDates;
    private _availableDates;
    private _daysOfWeekDisabled;
    private minYear;
    private minMonth;
    private maxYear;
    private maxMonth;
    private selectedDate;
    private outputDate;
    private startDate;
    private endDate;
    private hasSelectedBar;
    private hasInitDate;
    private isInited;
    constructor();
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private createEmptyDatePicker();
    private initDatePicker(date);
    private selectionEmitter(d, isInit?);
    private selectDate(d);
    private isDateSelected(d);
    private isDateDisbalbed(date);
    /**
     * Formate displaying month to full name
     */
    private renderTitle();
    private initInput();
    private calCalendar();
    private increaseMonth();
    private decreaseMonth();
    private isSelectedDay(y, m, d, num);
    private isHoliday(y, m, d, num);
    private calMonthEndDay(y, m, num);
    private clearCalendar();
    private resetCalendar(year, month);
    private selectBar(bar);
    private setAvailableDates(bar);
    private isBarSelected(bar);
    private renderDisplayDate(date);
    private toggleCalendar(isHidden?);
    private outputEvent();
}
export interface QuickDateBar {
    date?: Date;
    startDate?: Date;
    endDate?: Date;
    minDate?: Date;
    maxDate?: Date;
    disabledDates?: (Date | string)[];
    availableDates?: (Date | string)[];
    daysOfWeekDisabled?: number[];
    label?: string;
    value?: string;
    monthly?: true;
    children?: QuickDateBar;
}
export interface OutputDate {
    date?: Date;
    startDate?: Date;
    endDate?: Date;
    dateType?: QuickDateBar;
}
